//
//	Copyright (C) 2003 Kazuhiko TAMURA. All rights reserved.
//
//	This library is free software; you can redistribute it and/or
//	modify it under the terms of the GNU Lesser General Public
//	License as published by the Free Software Foundation; either
//	version 2.1 of the License, or (at your option) any later version.
//
//	This library is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//	Lesser General Public License for more details.
//
//	You should have received a copy of the GNU Lesser General Public
//	License along with this library; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//	NAME:		AbstractDecoratedModel.java
//	DATE:		2003.6.4
//	CREATOR:	Kazuhiko TAMURA
//
// ***************************************************************************************

package jp.gr.java_conf.ktz.puzzle.framework;

/**
 *	Decoraterp^[ŎfB
 *	ł́AׂĂ͓̎qõ\bhĂԂB
 *	<code>AbstractDecoratedModel</code>gNXŁA
 *	KvɉāA\bhI[o[Ch邱
 */
public abstract class AbstractDecoratedModel implements Model {
	/** qɂ郂f */
	protected Model mModel;
		
	/**
	 *	ftHgRXgN^
	 *	NullModelœqf
	 */
	protected AbstractDecoratedModel() {
		this(NullModel.getInstance());
	}
		
	/**
	 *	RXgN^
	 *
	 *	@param	inModel	qɂ郂f
	 */
	protected AbstractDecoratedModel(Model inModel) {
		addModel(inModel);
	}
	
	public void addModel(Model inModel) {
		mModel = inModel;
	}
	
	/**
	 *	w肳ꂽTCỸ{[h쐬B
	 *
	 *	@param	inWidth	̌
	 *	@param	inHeight	č
	 */
	public final void createBoard(final int inWidth, final int inHeight) {
		createBoardSelf(inWidth, inHeight);
		
		mModel.createBoard(inWidth, inHeight);
	}
	
	/**
	 *	w肳ꂽTCỸ{[h쐬B
	 *	œ̏s
	 *
	 *	@param	inWidth	̌
	 *	@param	inHeight	č
	 */
	public abstract void createBoardSelf(final int inWidth, final int inHeight);
	
	/**
	 *	ݒ肷B
	 *
	 * 	@param	inProblem	̏
	 */
	public void setProblem(ProblemInfo inProblem) {
		mModel.setProblem(inProblem);
	}
	
	/**
	 *	݂̏Ԃǂ`FbNB
	 *
	 *	@return ȂtrueԂ
	 */
	public boolean check() {
		return mModel.check();
	}
	
	/**
	 *	Ԃɖ߂
	 */
	public void reset() {
		mModel.reset();
	}
	
	
	/**
	 *	{[h̃TCYԂ 
	 *
	 *	@return TCY
	 */
	public java.awt.Dimension getSize() {
		return mModel.getSize();
	}
	
	/**
	 *	{[h̕Ԃ 
	 *
	 *	@return 
	 */
	public int getWidth() {
		return mModel.getWidth();
	}
	
	/**
	 *	{[h̍Ԃ 
	 *
	 *	@return 
	 */
	public int getHeight() {
		return mModel.getHeight();
	}
	
	/**
	 *	w肳ꂽʒu̖ʂ̏ԂԂB
	 *
	 *	@param inX	XW
	 *	@param	inY	YW
	 *	@return 
	 */
	public State getCurStateAt(final int inX, final int inY) {
		return mModel.getCurStateAt(inX, inY);
	}
	
	/**
	 *	w肳ꂽʒu̖ʂ̐ԂԂB
	 *
	 *	@param inX	XW
	 *	@param	inY	YW
	 *	@return 
	 */
	public State getCorrectStateAt(final int inX, final int inY) {
		return mModel.getCorrectStateAt(inX, inY);
	}

	/**
	 *	w肳ꂽStateEventCodẽfŏł邩ǂ`FbNB
	 *
	 *	@param	inCode`FbNStateEventCode
	 *	@return	̃fŏł̂ł΁AtrueԂ
	 */
	public abstract boolean isAcceptableEvent(StateEventCode inCode);

	/** 
	 *	w肳ꂽʒu̖ʂ̏Ԃ1i߂B
	 *
	 * 	@param inX	XW
	 *	@param	inY	YW
	 */
	public void nextStateAt(final int inX, final int inY) {
		mModel.nextStateAt(inX, inY);
	}
	
	/**
	 *	w肵Ֆʂ̈ʒȕԂɑJڂB
	 *	inCodelɏ]ēJڂԂƂȂĂB
	 *
	 *	@param	inX XWiBoardWnj
	 *	@param	inY YWiBoardWnj
	 *	@param	inCode ԂJڂ邽߂̃CxgR[h
	 */
	public void nextStateAt(final int inX, final int inY, StateEventCode inCode) {
		mModel.nextStateAt(inX, inY, inCode);
	}
	
	/** 
	 *	w肳ꂽʒu̖ʂ̏Ԃ1߂B
	 *
	 * 	@param inX	XW
	 *	@param	inY	YW
	 */
	public void prevStateAt(final int inX, final int inY) {
		mModel.prevStateAt(inX, inY);
	}
	
	/** 
	 *	w肳ꂽʒu̖ʂ̏Ԃ1߂
	 *	inCodelɏ]ēJڂԂƂȂĂB
	 *
	 *	@param	inX XWiBoardWnj
	 *	@param	inY YWiBoardWnj
	 *	@param	inCode ԂJڂ邽߂̃CxgR[h
	 */
	public void prevStateAt(final int inX, final int inY, StateEventCode inCode) {
		mModel.prevStateAt(inX, inY, inCode);
	}
	
	/** 
	 *	ŌɏCʂ̈ʒuԂ
	 *	̎ł́AׂĂModelKwǂāACʂ̈ʒuW
	 *
	 *	@return ŌɏCʂ̈ʒuԂ
	 */
	public final java.awt.Point[] lastModified() {
		java.util.Set aSet = new java.util.HashSet();
		
		aSet.addAll(java.util.Arrays.asList(mModel.lastModified()));
		aSet.addAll(java.util.Arrays.asList(lastModifiedSelf()));
		
		java.awt.Point[] aModified = new java.awt.Point[aSet.size()];
		aSet.toArray(aModified);
		
		return aModified;
	}
	
	/** 
	 *	@return ŌɏCʂ̈ʒuԂ
	 */
	protected abstract java.awt.Point[] lastModifiedSelf();
	
	/**
	 *	w肳ꂽʒu{[ḧǂׂ 
	 *
	 *	@param	inX	XW
	 *	@param	inY	YW
	 *	@return	{[ḧȂtrue
	 */
	public boolean contains(final int inX, final int inY) {
		return mModel.contains(inX, inY);
	}

	/**
	 *	w肳ꂽʒu̖ʂJڂł邩ǂׂB
	 *
	 *	@param	inX XW
	 *	@param	inY YW
	 *	@return	Jڂł̂ł΁AtrueԂB
	 */
	public boolean isTransitAt(final int inX, final int inY) {
		return mModel.isTransitAt(inX, inY);
	}
	
	/**
	 *	w肳ꂽʒu̖ʂJڂł邩ǂׂB
	 *
	 *	@param	inX XW
	 *	@param	inY YW
	 *	@param	inTransitCode JڂɊւl
	 *	@return	Jڂł̂ł΁AtrueԂB
	 */
	public boolean isTransitAt(
			final int inX, final int inY, 
			StateEventCode inTransitCode)
	{
		return mModel.isTransitAt(inX, inY, inTransitCode);
	}
	
	/**
	 *	w肳ꂽʒu̖ʂ󔒂ǂׂB
	 *
	 *	@param inX	XW
	 *	@param	inY	YW
	 *	@return	󔒂Ȃtrue
	 */
	public boolean isSpaceAt(final int inX, final int inY) {
		return mModel.isSpaceAt(inX, inY);
	}
	
	/**
	 *	w肳ꂽʒu̖ʂǂׂB
	 *
	 *	@param inX	XW
	 *	@param	inY	YW
	 *	@return	Ȃtrue
	 */
	public boolean isNumberAt(final int inX, final int inY) {
		return mModel.isNumberAt(inX, inY);
	}

	/**
	 *	ModelύXꂽǂ𒲂ׂB
	 *	̎ł́AModelKŵA1łύXF߂trueԂB
	 *
	 *	@return	ύXĂtrueԂB
	 */
	public final boolean isModified() {
		return (mModel.isModified() || isModifiedSelf()) ? true : false;
	}
	
	/**
	 *	gModelύXꂽǂ𒲂ׂB
	 *
	 *	@return	ύXĂtrueԂB
	 */
	protected abstract boolean isModifiedSelf();
	
	/**
	 *	Model̕ύXNA
	 *	̎ł́AׂĂModelKwǂ悤ɂĂ
	 *	XModel̎ɂĂflushSelfI()
	 */
	public final void flush() {
		mModel.flush();
		
		flushSelf();
	}
	
	protected abstract void flushSelf();
}	
	